package com.milanpresse.engineaddons.gamesprotos
{
   import com.milanpresse.engine.config.Config;
   import com.milanpresse.engineaddons.facades.GameEngine;
   import flash.display.MovieClip;
   import flash.display.Stage;
   import flash.system.ApplicationDomain;
   
   public dynamic class Actor implements IElementBase
   {
      protected var _e:GameEngine;
      
      protected var game:GameEngine;
      
      public var config:Config;
      
      public var stage:Stage;
      
      protected var actors:Vector.<Actor>;
      
      protected var _name:String;
      
      protected var _parentActor:Actor = null;
      
      protected var isSleeping:Boolean = false;
      
      public var vars:Object;
      
      protected var sleepExtern:Function = null;
      
      protected var wakeExtern:Function = null;
      
      protected var destroyExtern:Function = null;
      
      public function Actor(param1:GameEngine, param2:Actor = null, param3:* = null)
      {
         this.actors = new Vector.<Actor>();
         this.vars = {};
         super();
         this._e = this.game = param1;
         this._parentActor = param2;
      }
      
      public function start() : void
      {
      }
      
      public function addActor(param1:*) : *
      {
         var _loc2_:MovieClip = null;
         var _loc3_:Class = null;
         var _loc5_:String = null;
         if(param1 is Actor)
         {
            this.actors.push(param1);
            param1.parentActor = this;
            return param1;
         }
         if(param1.type == undefined || param1.type == null)
         {
            _loc3_ = ApplicationDomain.currentDomain.getDefinition("com.milanpresse.engineaddons.gamesprotos.actors.actorClip.ActorClip") as Class;
         }
         else if(param1.type is Class)
         {
            _loc3_ = param1.type;
         }
         else if(param1.type is String)
         {
            _loc3_ = ApplicationDomain.currentDomain.getDefinition(param1.type) as Class;
         }
         var _loc4_:Actor = _loc3_["create"](this._e,param1);
         if(_loc4_ == null)
         {
            for(_loc5_ in param1)
            {
            }
            return null;
         }
         _loc4_.parentActor = this;
         if(param1.name != undefined)
         {
            _loc4_.name = param1.name;
         }
         this.actors.push(_loc4_);
         return _loc4_;
      }
      
      public function getActor(param1:*) : *
      {
         var _loc2_:int = 0;
         var _loc3_:int = 0;
         if(param1 is Actor)
         {
            _loc2_ = int(this.actors.indexOf(param1));
            if(_loc2_ != -1)
            {
               return this.actors[_loc2_];
            }
         }
         else if(param1 is String)
         {
            _loc3_ = 0;
            while(_loc3_ < this.actors.length)
            {
               if(this.actors[_loc3_].name == param1)
               {
                  return this.actors[_loc3_];
               }
               _loc3_++;
            }
         }
         return null;
      }
      
      public function removeActor(param1:Actor) : void
      {
         if(this.actors.indexOf(param1) != -1)
         {
            this.actors.splice(this.actors.indexOf(param1),1);
         }
      }
      
      public function get sleep() : Function
      {
         return this._sleep;
      }
      
      public function set sleep(param1:Function) : void
      {
         this.sleepExtern = param1;
      }
      
      protected function _sleep() : void
      {
         if(this.sleepExtern != null)
         {
            this.sleepExtern();
         }
         var _loc1_:int = 0;
         while(_loc1_ < this.actors.length)
         {
            if(this.actors[_loc1_] != null)
            {
               this.actors[_loc1_].sleep();
            }
            _loc1_++;
         }
      }
      
      public function get wake() : Function
      {
         return this._wake;
      }
      
      public function set wake(param1:Function) : void
      {
         this.wakeExtern = param1;
      }
      
      protected function _wake() : void
      {
         if(this.wakeExtern != null)
         {
            this.wakeExtern();
         }
         var _loc1_:int = 0;
         while(_loc1_ < this.actors.length)
         {
            if(this.actors[_loc1_] != null)
            {
               this.actors[_loc1_].wake();
            }
            _loc1_++;
         }
      }
      
      public function foreach(param1:Function) : void
      {
         var _loc2_:Vector.<Actor> = this.actors.slice();
         var _loc3_:int = int(_loc2_.length);
         var _loc4_:int = 0;
         while(_loc4_ < _loc3_)
         {
            if(_loc2_[_loc4_] != null)
            {
               param1(_loc2_[_loc4_]);
            }
            _loc4_++;
         }
      }
      
      public function get destroy() : Function
      {
         return this._destroy;
      }
      
      public function set destroy(param1:Function) : void
      {
         this.destroyExtern = param1;
      }
      
      protected function _destroy() : void
      {
         if(this.destroyExtern != null)
         {
            this.destroyExtern();
         }
         var _loc1_:Vector.<Actor> = this.actors.slice();
         var _loc2_:int = int(_loc1_.length);
         var _loc3_:int = 0;
         while(_loc3_ < _loc2_)
         {
            if(_loc1_[_loc3_] != null)
            {
               _loc1_[_loc3_].destroy();
            }
            _loc3_++;
         }
         this.actors.length = 0;
         if(this._parentActor != null)
         {
            this._parentActor.removeActor(this);
         }
      }
      
      public function restore() : void
      {
         var _loc1_:Vector.<Actor> = this.actors.slice();
         var _loc2_:int = int(_loc1_.length);
         var _loc3_:int = 0;
         while(_loc3_ < _loc2_)
         {
            if(_loc1_[_loc3_] != null)
            {
               _loc1_[_loc3_].restore();
            }
            _loc3_++;
         }
      }
      
      public function dissociate() : void
      {
         var _loc1_:Vector.<Actor> = this.actors.slice();
         var _loc2_:int = int(_loc1_.length);
         var _loc3_:int = 0;
         while(_loc3_ < _loc2_)
         {
            if(_loc1_[_loc3_] != null)
            {
               _loc1_[_loc3_].dissociate();
            }
            _loc3_++;
         }
      }
      
      public function get name() : String
      {
         return this._name;
      }
      
      public function set name(param1:String) : void
      {
         this._name = param1;
      }
      
      public function get parentActor() : Actor
      {
         return this._parentActor;
      }
      
      public function set parentActor(param1:Actor) : void
      {
         this._parentActor = param1;
      }
   }
}

