package com.milanpresse.engineaddons.timelines
{
   import com.milanpresse.engine.Engine;
   import com.milanpresse.engine.managers.TimelineManager;
   import com.milanpresse.engine.text.TextBloc;
   import com.milanpresse.tools.GlobalesFunctions;
   import flash.display.DisplayObject;
   import flash.display.FrameLabel;
   import flash.display.MovieClip;
   import flash.events.Event;
   
   public class Timeline
   {
      private var _movie:MovieClip;
      
      private var timelineManager:TimelineManager;
      
      private var _engine:Engine;
      
      private var _legendesMedias:Array;
      
      public function Timeline(param1:MovieClip, param2:TimelineManager, param3:Engine = null)
      {
         this._legendesMedias = [];
         super();
         this._movie = param1;
         this._movie.timeline = this;
         this.timelineManager = param2;
         if(param3 !== null)
         {
            this._engine = param3;
         }
      }
      
      public function destroy() : void
      {
         this.kilListeners();
      }
      
      public function kilListeners() : void
      {
         var _loc1_:* = undefined;
         if(this._movie.hasEventListener(Event.FRAME_CONSTRUCTED))
         {
            this._movie.removeEventListener(Event.FRAME_CONSTRUCTED,this._movie.functionListener);
         }
         for(_loc1_ in this._movie)
         {
            if(this._movie[_loc1_] is MovieClip)
            {
               if(this._movie[_loc1_].hasEventListener(Event.FRAME_CONSTRUCTED))
               {
                  if(this._movie[_loc1_].functionListener !== undefined)
                  {
                     this._movie[_loc1_].removeEventListener(Event.FRAME_CONSTRUCTED,this._movie[_loc1_].functionListener);
                  }
               }
            }
         }
      }
      
      public function removeListeners(param1:MovieClip) : void
      {
         if(param1.hasEventListener(Event.FRAME_CONSTRUCTED))
         {
            if(param1.removeListeners is Function)
            {
               param1.removeListeners();
            }
         }
      }
      
      public function GotoAndStop(param1:*, param2:Function = null) : void
      {
         this.legendesMediasHide();
         this.removeListeners(this._movie);
         this._movie.gotoAndStop(param1);
         this.timelineManager.addMovie(this._movie);
         this.legendesMediasShow();
      }
      
      public function Stop() : void
      {
         this.removeListeners(this._movie);
         this.timelineManager.addMovie(this._movie);
         this._movie.stop();
      }
      
      public function Play() : void
      {
         this.removeListeners(this._movie);
         this.timelineManager.removeMovie(this._movie);
         this._movie.play();
      }
      
      public function GotoAndPlay(param1:*) : void
      {
         this.removeListeners(this._movie);
         this._movie.gotoAndPlay(param1);
         this.timelineManager.removeMovie(this._movie);
      }
      
      public function GotoAndPlayFrame1() : void
      {
         this.removeListeners(this._movie);
         this._movie.gotoAndPlay(1);
         this.timelineManager.removeMovie(this._movie);
      }
      
      public function GotoAndPlayLoop(param1:*) : void
      {
         var frameContructedListenerStop:Function = null;
         var frameContructedListenerPlay:Function = null;
         var frameStop:int = 0;
         var pPos:int = 0;
         var frameOrLabel:* = param1;
         this.removeListeners(this._movie);
         frameContructedListenerStop = function():void
         {
            if(_movie.currentFrame == frameStop)
            {
               _movie.gotoAndPlay(frameOrLabel);
            }
         };
         frameContructedListenerPlay = function():void
         {
            if(_movie.currentFrame == frameOrLabel)
            {
               _movie.removeEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerPlay);
               _movie.addEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerStop);
               _movie.functionListener = frameContructedListenerStop;
               legendesMediasShow();
            }
         };
         this._movie.addEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerPlay);
         this._movie.functionListener = frameContructedListenerPlay;
         if(frameOrLabel is String)
         {
            pPos = this.getPosFrameLabelByName(this._movie,frameOrLabel);
            if(pPos == -1)
            {
               return;
            }
            if(pPos < this._movie.currentLabels.length - 1)
            {
               frameStop = int(this._movie.currentLabels[pPos + 1].frame);
            }
            else
            {
               frameStop = this._movie.totalFrames;
            }
            frameOrLabel = this.turnLabelIntoFrame(this._movie,frameOrLabel);
         }
         else
         {
            pPos = this.getPosFrameLabelByName(this._movie,this._movie.currentLabel);
            if(pPos < this._movie.currentLabels.length - 1)
            {
               frameStop = int(this._movie.currentLabels[pPos + 1].frame);
            }
            else
            {
               frameStop = this._movie.totalFrames;
            }
         }
         this.legendesMediasHide();
         this._movie.gotoAndPlay(frameOrLabel);
         this.timelineManager.removeMovie(this._movie);
      }
      
      public function GotoAndPlayUntilTheEnd(param1:*, param2:Function = null) : void
      {
         var frameStop:int = 0;
         var frameContructedListenerStop:Function = null;
         var frameContructedListenerPlay:Function = null;
         var frameOrLabel:* = param1;
         var callback:Function = param2;
         this.removeListeners(this._movie);
         this.timelineManager.removeMovie(this._movie);
         frameStop = this._movie.totalFrames;
         frameContructedListenerStop = function():void
         {
            if(_movie.currentFrame == frameStop)
            {
               legendesMediasShow();
               _movie.functionListener = undefined;
               _movie.removeEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerStop);
               _movie.stop();
               timelineManager.addMovie(_movie);
               if(callback !== null)
               {
                  callback();
               }
            }
         };
         frameContructedListenerPlay = function():void
         {
            if(_movie.currentFrame == frameOrLabel)
            {
               _movie.removeEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerPlay);
               _movie.addEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerStop);
               _movie.functionListener = frameContructedListenerStop;
               legendesMediasShow();
            }
         };
         this._movie.addEventListener(Event.FRAME_CONSTRUCTED,frameContructedListenerPlay);
         this._movie.functionListener = frameContructedListenerPlay;
         if(frameOrLabel is String)
         {
            frameOrLabel = this.turnLabelIntoFrame(this._movie,frameOrLabel);
         }
         this.legendesMediasHide();
         this._movie.gotoAndPlay(frameOrLabel);
      }
      
      public function GotoAndPlayUntil(param1:Object) : void
      {
         var theMovie:MovieClip = null;
         var framePlay:int = 0;
         var frameStop:int = 0;
         var isOK:Boolean = false;
         var frameContructedListener:Function = null;
         var enterFrameListener:Function = null;
         var p:Object = param1;
         if(p.mc == undefined)
         {
            theMovie = this._movie;
            this.removeListeners(this._movie);
         }
         else
         {
            theMovie = p.mc;
         }
         p.callback = p.callback == undefined ? null : p.callback;
         if(typeof p.labelPlay == "string")
         {
            framePlay = this.turnLabelIntoFrame(theMovie,p.labelPlay);
         }
         else
         {
            framePlay = int(p.labelPlay);
         }
         if(p.labelStop !== undefined)
         {
            if(typeof p.labelStop == "string")
            {
               frameStop = this.turnLabelIntoFrame(theMovie,p.labelStop);
            }
            else
            {
               frameStop = int(p.labelStop);
            }
         }
         else if(p.beforeLabelStop !== undefined)
         {
            frameStop = this.turnLabelIntoFrame(theMovie,p.beforeLabelStop) - 1;
         }
         isOK = false;
         frameContructedListener = function():void
         {
            isOK = false;
            if(p.labelStop !== undefined || p.beforeLabelStop !== undefined)
            {
               if(theMovie.currentFrame == frameStop)
               {
                  isOK = true;
               }
            }
            else
            {
               isOK = true;
            }
            if(isOK)
            {
               if(p.labelPlay == undefined)
               {
                  legendesMediasShow();
               }
               theMovie.functionListener = undefined;
               theMovie.removeEventListener(Event.FRAME_CONSTRUCTED,frameContructedListener);
               if(p.afterLabelStop !== undefined)
               {
                  theMovie.gotoAndStop(p.afterLabelStop);
               }
               else
               {
                  theMovie.stop();
               }
               timelineManager.addMovie(theMovie);
               if(typeof p.callback == "function")
               {
                  p.callback();
               }
            }
         };
         enterFrameListener = function():void
         {
            if(p.labelPlay !== undefined)
            {
               if(theMovie.currentFrame == framePlay)
               {
                  isOK = true;
               }
            }
            else
            {
               isOK = true;
            }
            if(isOK)
            {
               legendesMediasShow();
               theMovie.removeEventListener(Event.FRAME_CONSTRUCTED,enterFrameListener);
               theMovie.functionListener = frameContructedListener;
               theMovie.addEventListener(Event.FRAME_CONSTRUCTED,frameContructedListener);
            }
         };
         theMovie.removeListeners = function():void
         {
            this.removeEventListener(Event.FRAME_CONSTRUCTED,enterFrameListener);
            this.removeEventListener(Event.FRAME_CONSTRUCTED,frameContructedListener);
            theMovie.functionListener = undefined;
         };
         this.legendesMediasHide();
         if(p.labelPlay == undefined)
         {
            theMovie.functionListener = frameContructedListener;
            theMovie.addEventListener(Event.FRAME_CONSTRUCTED,frameContructedListener);
            theMovie.gotoAndStop(frameStop);
            this.timelineManager.addMovie(theMovie);
         }
         else
         {
            theMovie.functionListener = enterFrameListener;
            theMovie.addEventListener(Event.FRAME_CONSTRUCTED,enterFrameListener);
            theMovie.gotoAndPlay(framePlay);
            this.timelineManager.removeMovie(theMovie);
         }
      }
      
      public function hasLabel(param1:MovieClip, param2:String) : Boolean
      {
         var _loc3_:int = 0;
         while(_loc3_ < param1.currentLabels.length)
         {
            if(param2 == param1.currentLabels[_loc3_].name)
            {
               return true;
            }
            _loc3_++;
         }
         return false;
      }
      
      public function getFrameLabelByName(param1:MovieClip, param2:String) : FrameLabel
      {
         var _loc3_:int = 0;
         while(_loc3_ < param1.currentLabels.length)
         {
            if(param1.currentLabels[_loc3_].name == param2)
            {
               return param1.currentLabels[_loc3_];
            }
            _loc3_++;
         }
         return null;
      }
      
      public function getFrameLabel(param1:MovieClip, param2:int) : FrameLabel
      {
         var _loc3_:int = 0;
         while(_loc3_ < param1.currentLabels.length)
         {
            if(param1.currentLabels[_loc3_].frame == param2)
            {
               return param1.currentLabels[_loc3_];
            }
            _loc3_++;
         }
         return null;
      }
      
      public function turnLabelIntoFrame(param1:MovieClip, param2:String) : int
      {
         var _loc3_:int = -1;
         if(this.hasLabel(param1,param2))
         {
            _loc3_ = this.getFrameLabelByName(param1,param2).frame;
         }
         return _loc3_;
      }
      
      public function getPosFrameLabelByName(param1:MovieClip, param2:String) : int
      {
         var _loc3_:int = 0;
         while(_loc3_ < param1.currentLabels.length)
         {
            if(param1.currentLabels[_loc3_].name == param2)
            {
               break;
            }
            _loc3_++;
         }
         return _loc3_;
      }
      
      public function legendesMediasShow() : void
      {
         var _loc1_:Vector.<DisplayObject> = null;
         var _loc2_:int = 0;
         var _loc3_:Array = null;
         var _loc4_:String = null;
         var _loc5_:int = 0;
         var _loc6_:TextBloc = null;
         if(this._engine !== null)
         {
            _loc1_ = GlobalesFunctions.getChildrenByNameRecursive(this._movie,"^texte_");
            _loc2_ = int(_loc1_.length);
            _loc5_ = 0;
            while(_loc5_ < _loc2_)
            {
               _loc3_ = _loc1_[_loc5_].name.match(/^texte_([^$]+)\$*(.*)/);
               _loc4_ = _loc3_[1];
               _loc6_ = this._engine.showLM({
                  "id":_loc4_,
                  "model":_loc1_[_loc5_]
               });
               if(this._legendesMedias.indexOf(_loc6_) !== -1)
               {
               }
               this._legendesMedias.push(_loc6_);
               _loc5_++;
            }
         }
      }
      
      public function legendesMediasHide() : void
      {
         var _loc1_:int = 0;
         if(this._engine !== null)
         {
            _loc1_ = 0;
            while(_loc1_ < this._legendesMedias.length)
            {
               this._engine.hideLM(this._legendesMedias[_loc1_]);
               _loc1_++;
            }
         }
      }
      
      public function get movie() : MovieClip
      {
         return this._movie;
      }
      
      public function set engine(param1:Engine) : void
      {
         this._engine = param1;
      }
   }
}

