package com.milanpresse.engineaddons.timelines
{
   import com.milanpresse.engine.Engine;
   import com.milanpresse.engine.managers.TimelineManager;
   import flash.display.MovieClip;
   import flash.events.Event;
   
   public class TimelineController
   {
      protected var _clip:MovieClip = null;
      
      protected var _levelFunction:* = null;
      
      protected var _timelineManager:* = null;
      
      protected var _labelsAction:Object;
      
      protected var frameLast:int = -1;
      
      protected var labelLast:String = null;
      
      protected var isRunning:Boolean = true;
      
      public function TimelineController(param1:MovieClip, param2:Engine, param3:*, param4:TimelineManager, param5:Object = null)
      {
         this._labelsAction = {};
         super();
         this._clip = param1;
         this._levelFunction = param3;
         this._timelineManager = param4;
         this._labelsAction = param5 == null ? {} : param5;
      }
      
      public function play(param1:* = null) : void
      {
         this.isRunning = true;
         this._clip.addEventListener(Event.EXIT_FRAME,this.frameExitHandler);
         this._clip.addEventListener(Event.FRAME_CONSTRUCTED,this.frameConstructedHandler);
         this._clip.gotoAndPlay(param1);
         this._timelineManager.removeMovie(this._clip);
      }
      
      protected function frameConstructedHandler(param1:Event) : void
      {
         if(this.isRunning && this._clip.currentFrameLabel != null && this.labelLast != this._clip.currentLabel)
         {
            this.labelLast = this._clip.currentLabel;
            if(this._levelFunction.onLabelEnter != null)
            {
               this._levelFunction.onLabelEnter({
                  "frame":this._clip.currentFrame,
                  "label":this._clip.currentFrameLabel
               });
            }
         }
         if(this.isRunning && this._clip.currentFrame != this.frameLast)
         {
            this.frameLast = this._clip.currentFrame;
            if(this._levelFunction.onFrameEnter != null)
            {
               this._levelFunction.onFrameEnter({
                  "frame":this._clip.currentFrame,
                  "label":this._clip.currentFrameLabel
               });
            }
         }
      }
      
      protected function frameExitHandler(param1:Event) : void
      {
         if(this._levelFunction.onFrameExit != null)
         {
            this._levelFunction.onFrameExit({
               "frame":this._clip.currentFrame,
               "label":this._clip.currentFrameLabel
            });
         }
      }
      
      public function stop(param1:* = null) : void
      {
         this.isRunning = false;
         this._clip.removeEventListener(Event.EXIT_FRAME,this.frameExitHandler);
         this._clip.removeEventListener(Event.FRAME_CONSTRUCTED,this.frameConstructedHandler);
         if(param1 == null)
         {
            this._clip.stop();
         }
         else
         {
            this._clip.gotoAndStop(param1);
         }
         this._timelineManager.addMovie(this._clip);
      }
      
      public function destroy() : void
      {
         if(this._clip != null)
         {
            this._clip.removeEventListener(Event.EXIT_FRAME,this.frameExitHandler);
            this._clip.removeEventListener(Event.FRAME_CONSTRUCTED,this.frameConstructedHandler);
         }
         this._clip = null;
      }
      
      public function get clip() : MovieClip
      {
         return this._clip;
      }
      
      public function set clip(param1:MovieClip) : void
      {
         this._clip = param1;
      }
   }
}

