package com.milanpresse.engineaddons.timers
{
   import flash.events.TimerEvent;
   import flash.utils.Timer;
   import flash.utils.getTimer;
   
   public class MainTimer
   {
      protected var _timer:Timer;
      
      protected var _delay:Number;
      
      protected var _repeatCount:Number;
      
      protected var _isSleeping:Boolean = false;
      
      protected var _listeners:Vector.<TimerChild>;
      
      protected var _listenersLength:int = 0;
      
      protected var running:Boolean = false;
      
      protected var _idUnique:int = 1;
      
      public var time:Number = 0;
      
      protected var _tempChild:TimerChild;
      
      protected var timerToWake:Boolean = false;
      
      public function MainTimer()
      {
         this._timer = new Timer(10);
         this._listeners = new Vector.<TimerChild>();
         super();
      }
      
      public function addFromObj(param1:Object) : TimerChild
      {
         var _loc2_:TimerChild = null;
         _loc2_ = new TimerChild(this);
         ++this._idUnique;
         _loc2_.id = param1.id == undefined ? "" : param1.id + this._idUnique;
         _loc2_.delay = param1.delay;
         _loc2_.loop = param1.loop == undefined ? 0 : int(param1.loop);
         _loc2_.func = param1.onDelay;
         _loc2_.running = true;
         _loc2_.timeStart = getTimer() - _loc2_.timeElapsed;
         this.add(_loc2_);
         return _loc2_;
      }
      
      public function add(param1:TimerChild) : void
      {
         if(this._listeners.indexOf(param1) == -1)
         {
            this._listeners.push(param1);
            this._listenersLength = this._listeners.length;
         }
      }
      
      public function removeAllChilds() : void
      {
         this._listeners.length = this._listenersLength = 0;
      }
      
      public function removeChild(param1:TimerChild) : void
      {
         if(this._listeners.indexOf(param1) != -1)
         {
            this._listeners.splice(this._listeners.indexOf(param1),1);
            this._listenersLength = this._listeners.length;
         }
      }
      
      public function start() : void
      {
         if(this.running)
         {
            return;
         }
         this.running = true;
         this._timer.addEventListener(TimerEvent.TIMER,this._timeHandler);
         this._timer.start();
      }
      
      protected function _timeHandler(param1:TimerEvent) : void
      {
         this.time = getTimer();
         for each(this._tempChild in this._listeners)
         {
            if(this.running == false)
            {
               return;
            }
            if((this._tempChild.timeElapsed = this.time - this._tempChild.timeStart) > this._tempChild.delay)
            {
               this._tempChild.timeStart = this.time;
               this._tempChild.timeElapsed = 0;
               this._tempChild.func(this._tempChild);
               if(this._tempChild.loop != 0)
               {
                  this._tempChild.stop();
               }
            }
         }
         param1.updateAfterEvent();
      }
      
      public function get numChildren() : int
      {
         return this._listenersLength;
      }
      
      public function stop() : void
      {
         if(this.running == false)
         {
            return;
         }
         this.running = false;
         this._timer.removeEventListener(TimerEvent.TIMER,this._timeHandler);
         this._timer.stop();
      }
      
      public function sleep() : void
      {
         if(this._isSleeping)
         {
            return;
         }
         this._isSleeping = true;
         if(this._timer.running)
         {
            this.timerToWake = true;
            this.stop();
         }
         this.stop();
      }
      
      public function wake() : void
      {
         var offsetTime:Number = NaN;
         if(this._isSleeping == false)
         {
            return;
         }
         this._isSleeping = false;
         if(this.timerToWake)
         {
            offsetTime = getTimer() - this.time;
            this._listeners.forEach(function(param1:*, param2:int, param3:Vector.<TimerChild>):void
            {
               param1.timeStart + offsetTime;
            },this);
            this.start();
         }
      }
      
      public function destroy() : void
      {
         this.stop();
         this.removeAllChilds();
      }
   }
}

